#include <iostream.h>

#include <conio.h>

#include <fstream.h>



void quicksort(int input_array[], int top, int bottom);

int partition(int input_array[], int top, int bottom);



void main()

{

	ifstream infile;

	ofstream outfile;

	int numbers[50];

	int i;

	int integersearch;

	int halfvalue = 12;

	infile.open("numbers.txt", ios::in);

	for(i=0;i<50;i++)

	{

		infile >> numbers[i];

	}

	infile.close();

	quicksort(numbers, 0, 49);

	outfile.open("numbers.txt", ios::out);

	for(i=0;i<50;i++)

	{

		outfile << numbers[i] << " ";

	}

	outfile.close();

	cout << "Please enter an integer to search for." << endl;

	cin >> integersearch;

	i = 26; //initial place to start

	do

	{

		if (integersearch==numbers[i-1]) //uses a 1-50 system so subtracts 1 to check

			break;

		else if (integersearch<numbers[i-1]) //if the target number is less than the current one, go up in the count

			i = i + halfvalue;

		else //if the target number is less than the current one, go down in the count

			i = i - halfvalue;

		if	(halfvalue==1) //when the half value reaches 1, their are only 3 places left to check

		{

			if (integersearch==numbers[i - 1]) //checks the place thecounter is on

				break;

			else if (integersearch==numbers[i - 2]) //checks the place one below what the counter is on

				i--;

			else if (integersearch==numbers[i]) //checks the place one above the counter

				i++;

			else //if the value is not found, halfvalue is set to 0, telling the compiler the number was not found.

				halfvalue = 0;

			break;

		}

		halfvalue = (halfvalue / 2) + (halfvalue % 2); //halves the number to be added or subtracted from the counter

	}

	while(halfvalue!=0);

	if (halfvalue==0)

		cout << "Your number was not found in the list." << endl;

	else

		cout << "Your number, " << integersearch << ", was in position " << i << " of 50 in the list." << endl;

	getch();

}



//functions taken from quicksort.cpp

void quicksort(int input_array[], int top, int bottom)

{

  int middle;  

  if (top < bottom)

   {

    middle = partition(input_array, top, bottom);

    quicksort(input_array, top, middle);

    quicksort(input_array, middle + 1, bottom);

   }

}



int partition(int input_array[], int top, int bottom)

{

  int x = input_array[top];

  int i = top - 1;

  int j = bottom + 1;

  int temp;

  do

   {

    do

     {

      j--;

     } while(x > input_array[j]);

    do

     {

      i++;

     } while(x < input_array[i]);



    if (i < j)

     {

      temp = input_array[i];

      input_array[i] = input_array[j];

      input_array[j] = temp;

     }

   } while(i < j);

   return j;

}

