// HIGHTEMP

// This program averages the high temperatures over a user-defined

// number of days.



#include<iostream.h>

#include<iomanip.h>

#include<conio.h>



struct daily_temp

{

  int temperature;

  daily_temp *next;

};

daily_temp *head_ptr;

daily_temp *current_ptr;

daily_temp *new_ptr;



int main()

{

  int newtemp;

  int num_values;             // number of days in a row to enter values

  int index;                  // index for loop counter and array access

  float average_high;         // calculated average high temperature

  int total = 0;              // used to total temps before averaging

  

  do  // loop to ask for number of days until valid input is received

  {

    cout << "Enter the number of days for which you have data: ";

    cin >> num_values;

    if ((num_values < 1))

      cout << "The number of days must be greater than 1" << endl;

  } while (num_values < 1);



  // The following loop gets the high temperatures from the user for as

  // many days as the user specified in num_values. The subscript 0 is

  // not used so that the subscript will correspond with the day number.

  head_ptr = new daily_temp;

  head_ptr->next = NULL;

  current_ptr = head_ptr;

  for(index = 1; index <= num_values; index++)

   {

    cout << "Enter the high temperature for day " << index << ": ";

    cin >> newtemp;  // input value into array

    if (index!=1)

    {

      new_ptr = new daily_temp;

      current_ptr->next = new_ptr;

      current_ptr = new_ptr;

    }

    current_ptr->temperature = newtemp;

    current_ptr->next = NULL;

   }



  // Print the values in the array to the screen.

  cout << "The array contains high temperatures for " << num_values

       << " days.\n";

  cout << "The values are as follows.\n";

  current_ptr = head_ptr;

  index=1;

  do

   {

    cout << "Day " << index << ": " << current_ptr->temperature << endl;

    index++;

    total = total + current_ptr->temperature; // update total for averaging

    current_ptr = current_ptr->next;

   }

   while (current_ptr != NULL);



  // Calculate average by typecasting total and num_values to floats

  // before dividing and assigning the result to average_high.

  average_high = (float) total / (float) num_values;



  // Print the results to the screen.

  cout << "The average high temperature during the " << num_values

       << "-day period was " << setprecision(2) << average_high

       << " degrees.\n";



  getch();

  return 0;

}

